;TIP1046.LSP:  CLR.LSP     Select by Color     (C)1994, Grant Kiba

;Collection function
;--------------------------------------------------------------------
(defun collect (E1)              ;Define the collection funtion
   (if (= c nil)                 ;Set if no selection set
      (setq C(ssadd E1)) ;THEN   ;Then create the set
      (setq C(ssadd E1 C)) ;ELSE ;or add this object to the current set
   );end if
);end defun

;Color selection function
;-------------------------------------------------------------------
(defun clr (/ A B C COUNT NUM CLRLAY) ;Define function
   (setq COUNT 0)              ;Set counter to 0
   (initget 6)                 ;Don't negative values
   (princ "\nRed=1,Yellow-2,Green=3,Cyan=4,Blue=5,Magenta=6,White=7,Byblock=0")
   (setq CLRNUM (getint"\nEnter color number or press \"Enter\" to select: "))   ;Get color number
   (if(= CLRNUM nil)
      (progn
         (initget 1)
         (setq SAMPLE (entget(car(entsel "\nSelect object /w color to filter: "))))
         (if  (null (assoc 62 SAMPLE))
            (progn ;THEN
               (setq LAY(cdr(assoc 8 SAMPLE)))
               (setq CLRNUM(cdr(assoc 62 (tblsearch "layer" LAY))))
            );end progn
            (setq CLRNUM (cdr (assoc 62  SAMPLE))) ;ELSE
         );end if
      );end progn
   );end if
   (setq MSG (strcat "\nFiltering color #" (itoa CLRNUM)))
   (princ MSG)
   (princ "\nWindow or select objects to filter then press \"Enter\"")
   (while (null A)
      (setq A (ssget))                     ;Get initial selection
      (if (null A) (princ "No objects to filter! Select again or ^C to abort."))
   );end while
   (setq NUM (sslength A))                 ;Get number of objects selected
   (while (< COUNT NUM)
      (setq B (entget (ssname A COUNT)))   ;Get entity list
      (if (/= (assoc 62 B) nil)            ;If the object has a color
         ;THEN
         (if (equal (assoc 62 B) (cons 62 CLRNUM))  ;If the color matches
            (collect (ssname A COUNT))     ;Then Collect object
         );end if
         ;ELSE                             ;Else get object's layer
         (progn
            (setq LAY(cdr(assoc 8 B)))
            (setq CLRLAY(cdr(assoc 62 (tblsearch "layer" LAY))))
            (if (= CLRNUM CLRLAY)                   ;If the layer matches color
               (collect (ssname A COUNT))           ;Collect the object
            );end if
         );end progn
      );end if
      (setq COUNT (+ 1 COUNT))           ;Check next object in set
   );end while
   (if (null C)
      (progn
         (command "")
         (princ "No objects match filter color!")
         (princ)
      );end progn
      (setq X C)         ;Sends the selection set to the current commad
   );end if
);end clr.lsp



